/***********************************************
 *	FILE:	Accel_BMA180.h
 *
 *	AUTHORS:	-Guillermo Maroto
 *
 *	Based on Aeroquad.com - Accel.h         
 *   --------+--------         --------+--------
 *          | |_______________________| | 
 *                   |         |
 *                   |_________|
 *                 ~____|___|____    
 **********************************************/

#pragma once

#include "Accel.h"
#include "I2C.h"
#include "MathFilter.h"

class Accel_BMA180 : public Accel 
{
	private:
		int accelAddress;
		
	public:
	Accel_BMA180() : Accel()
	{
		accelAddress = 0x40; // page 54 and 61 of datasheet
		accelScaleFactor = G_2_MPS2(1.0/4096.0);  //  g per LSB @ +/- 2g range
	}
		
	void initialize(void) ;
		
	void measure(void);
		
	const int getFlightData(byte axis)
	{
		return getRaw(axis) >> 3;
	}
		
		// Allows user to zero accelerometers on command
	void calibrate(void);
};