/***********************************************
 *	FILE:	DataStorage.cpp
 *
 *	AUTHORS:	-Guillermo Maroto
 *
 *	Based on Aeroquad.com - DataStorage.h         
 *   --------+--------         --------+--------
 *          | |_______________________| | 
 *                   |         |
 *                   |_________|
 *                 ~____|___|____    
 **********************************************/

#include "DataStorage.h"

// Special thanks for 1k space optimization update from Ala42
// http://aeroquad.com/showthread.php?1369-The-big-enhancement-addition-to-2.0-code&p=13359&viewfull=1#post13359

// Utilities for writing and reading from the EEPROM
float readFloat(int address) {
	union floatStore {
		byte floatByte[4];
		float floatVal;
	} floatOut;
	
	for (int i = 0; i < 4; i++)
		floatOut.floatByte[i] = EEPROM.read(address + i);
	return floatOut.floatVal;
}

void writeFloat(float value, int address) {
	union floatStore {
		byte floatByte[4];
		float floatVal;
	} floatIn;
	
	floatIn.floatVal = value;
	for (int i = 0; i < 4; i++)
		EEPROM.write(address + i, floatIn.floatByte[i]);
}



//Se deja de prueba para futuros desarrollos (future developments)
/*
// contains all default values when re-writing EEPROM

 void initializeEEPROM(void) {
 
 // AKA - old setOneG not in SI - accel.setOneG(500);
 accel.setOneG(9.80665); // AKA set one G to 9.8 m/s^2

}
void readEEPROM(void) {
	
	accel.setOneG(readFloat(ACCEL1G_ADR));
	
}

void writeEEPROM(void){
	
	cli(); // Needed so that APM sensor data doesn't overflow

	writeFloat(accel.getOneG(), ACCEL1G_ADR);
	
	sei(); // Restart interrupts
}
*/