/***********************************************
 *	FILE:	Motor_PWM.h
 *
 *	AUTHORS:	-Guillermo Maroto
 *
 *           
 *   --------+--------         --------+--------
 *		    | |_______________________| | 
 *			         |         |
 *			   	     |_________|
 *				   ~____|___|____    
 **********************************************/
#pragma once

#include "MarotoCopter.h"
#include "Motor.h"

class Motor_PWM : public Motor 
{
	
private:	
	
	// Pines a los que conectar los ESC AeroQuadMega_v2
	#define FRONTMOTORPIN  2
	#define REARMOTORPIN   3
	#define RIGHTMOTORPIN  5
	#define LEFTMOTORPIN   6
	
	int pulse;	//Pulse Width Modulation, in microseconds
	byte pin;   

public:
	
	void initialize(int pinM);
	
	void write(int pulseM);
	
	void calibrate();
	
	int getPulse()
	{
		return pulse;
	}
	
};