/***********************************************
 *	FILE:	PID.cpp
 *
 *	AUTHORS:	-Guillermo Maroto
 *
 *	Modified from http://www.arduino.cc/playground/Main/BarebonesPIDForEspresso
 *  Modified from Aeroquad.com / PID.h
 *   --------+--------         --------+--------
 *		    | |_______________________| | 
 *			         |         |
 *			   	     |_________|
 *				   ~____|___|____    
 **********************************************/
#include "PID.h"

void PID::updatePID(float cP) 
{
	currentTime = micros();

	currentPosition=cP;
	float error;
	float dTerm;
	
	// AKA PID experiments
	float deltaPIDTime = (currentTime - previousPIDTime) / 1000000.0;
	previousPIDTime = currentTime;
  
	error = targetPosition - currentPosition;
  
	integratedError += error * deltaPIDTime;
	integratedError = constrain(integratedError, -windupGuard, windupGuard);
  
	dTerm = dgain * (currentPosition - lastPosition)/(deltaPIDTime * 100);
	
	lastPosition = currentPosition;
		
	Output = (pgain * error) + (igain * (integratedError)) + dTerm;
}

